/* -*- Mode: C; tab-width: 4; c-basic-offset: 4; indent-tabs-mode: nil -*- */

#include <ruby.h>
#include <proc/readproc.h>

static VALUE ge_mGC;
static VALUE ge_sym_vsize;

static VALUE
ge_procinfo_get(VALUE self)
{
    struct proc_t proc;
    VALUE ret;

    ret = rb_hash_new();
    look_up_our_self(&proc);
    rb_hash_aset(ret, ge_sym_vsize, ULONG2NUM(proc.vsize));

    (void)self;
    return ret;
}

    void
Init_gc_ext(void)
{
    ge_sym_vsize = ID2SYM(rb_intern("vsize"));

    ge_mGC = rb_const_get(rb_cObject, rb_intern("GC"));
    rb_define_singleton_method(ge_mGC, "procinfo", ge_procinfo_get, 0);
}
